/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.106 Revision 1.138
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.106 2011/12/21 22:47:35 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.138 2012/11/01 08:35:43 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in
13 2|3|4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
13 28
14MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
16 31
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/" 32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 43 fi
44 ;;
45esac
20 46
21IUSE="aqua debug pch" 47IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions"
26
27if version_is_at_least 4.7.99999999; then 49if version_is_at_least 4.8; then
28 IUSE+=" c++0x qpa" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
51 version_is_at_least 4.8.3 || IUSE+=" qpa"
29fi 52fi
30 53
31DEPEND="dev-util/pkgconfig" 54DEPEND="virtual/pkgconfig"
55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
57fi
58
32RDEPEND=" 59RDEPEND="
33 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
34 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
35 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
36 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
37 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
38 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
39 !<x11-libs/qt-declarative-${PV} 68 !<x11-libs/qt-declarative-${PV}:4
40 !>x11-libs/qt-declarative-${PV}-r9999 69 !>x11-libs/qt-declarative-${PV}-r9999:4
41 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
42 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
43 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
44 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
45 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
46 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
47 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
48 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
49 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
50 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
51 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
52 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
53 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
54 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
55 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
56 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
57 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
58 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
59 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
60 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
61 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
62 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
63 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
64 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
65" 96"
66 97
67S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
68 99
69# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
70# @DESCRIPTION: 101# @DESCRIPTION:
71# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
72qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
73 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
74 105
75 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
76 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
77 if has_version '>'${CATEGORY}/${P}-r9999; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
78 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
79 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
80 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
81 die "aborting to save your system" 112 die "aborting to save your system"
82 else 113 else
83 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
84 fi 115 fi
85 fi
86
87 if [[ ${PN} == "qt-webkit" ]]; then
88 eshopts_push -s extglob
89 if is-flagq '-g?(gdb)?([1-9])'; then
90 echo
91 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
92 ewarn "You may experience really long compilation times and/or increased memory usage."
93 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
94 ewarn "For more info check out bug #307861"
95 echo
96 fi
97 eshopts_pop
98 fi 116 fi
99 117
100 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
101 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
102 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
107 # avoid extract failure. 125 # avoid extract failure.
108 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
109 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
110 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
111 fi 129 fi
112
113 # Make sure ebuilds use the required EAPI
114 if [[ ${EAPI} != [23] ]]; then
115 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
116 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
117 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
118 die "qt4-build eclass requires EAPI=2 or EAPI=3"
119 fi
120
121 if ! version_is_at_least 4.1 $(gcc-version); then
122 ewarn "Using a GCC version lower than 4.1 is not supported!"
123 fi
124} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
125 137
126# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
127# @DESCRIPTION: 140# @DESCRIPTION:
128# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
129# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
130
131# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
132# @DESCRIPTION:
133# Space separated list including the directories that will be extracted from Qt
134# tarball
135 143
136# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
137# @DESCRIPTION: 145# @DESCRIPTION:
138# Unpacks the sources 146# Unpacks the sources.
139qt4-build_src_unpack() { 147qt4-build_src_unpack() {
140 setqtenv 148 setqtenv
141 local unpack_p="${MY_P}" 149
142 case "${PV}" in 150 if ! version_is_at_least 4.1 $(gcc-version); then
143 4.8.0_*) 151 ewarn "Using a GCC version lower than 4.1 is not supported."
144 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
145 ;; 170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
177 targets+="${MY_P}/${target} "
178 done
179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
182 eend $? || die "failed to unpack"
183 ;;
146 esac 184 esac
147 local target targets=
148 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
149 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
150 ${QT4_EXTRACT_DIRECTORIES}; do
151 targets+=" ${unpack_p}/${target}"
152 done
153
154 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
155 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
156 case "${PV}" in
157 4.8.0_*)
158 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
159 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
160 ;;
161 esac
162} 185}
163 186
164# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
165# @DESCRIPTION: 189# @DESCRIPTION:
166# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
167# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
168# example: 192# Make sure to specify the full path. This variable is utilised in
169# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
170# ${FILESDIR}"/mypatch2.patch"
171# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
172 199
173# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
174# @DESCRIPTION: 201# @DESCRIPTION:
175# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
176# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
177qt4-build_src_prepare() { 204qt4-build_src_prepare() {
178 setqtenv 205 setqtenv
179 cd "${S}"
180 206
181 # fix qt 4.7 regression that skips -fvisibility=hidden 207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
182 if version_is_at_least "4.7.0_beta1"; then 208 QTDIR="." ./bin/syncqt || die "syncqt failed"
183 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
184 -i config.tests/unix/fvisibility.test ||
185 die "visibility fixing sed failed"
186 fi 209 fi
187 210
188 if version_is_at_least "4.7"; then 211 if version_is_at_least 4.7; then
189 # fix libX11 dependency on non X packages 212 # avoid X11 dependency in non-gui packages
190 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
191 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
192
193 qt_assistant_cleanup
194 fi 215 fi
195 216
196 if use aqua; then 217 if use aqua; then
197 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
198 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
199 220
200 sed -e '/^CONFIG/s:app_bundle::' \ 221 sed -e '/^CONFIG/s:app_bundle::' \
201 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
202 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
203 fi 224 fi
204 225
205 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
206 skip_qmake_build 227 skip_qmake_build
207 skip_project_generation 228 skip_project_generation
208 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
209 fi 230 fi
210 231
211 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
212 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
213 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
214 fi 236 fi
215 237
216 # Bug 178652 238 # Bug 178652
217 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
218 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
219 append-flags -fno-gcse 241 append-flags -fno-gcse
220 fi 242 fi
221 243
222 if use_if_iuse c++0x; then 244 if use_if_iuse c++0x; then
223 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
224 ewarn "this is an official standard, some of the reverse dependencies"
225 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
226 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
227 ewarn "disabled."
228 append-flags -std=c++0x 245 append-cxxflags -std=c++0x
229 fi 246 fi
230 247
231 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
232 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
233 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
234 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
235 # Bug 253127 252 # Bug 253127
236 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
237 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
238 fi 255 fi
239 256
240 # Bug 261632 257 # Bug 261632
241 if use ppc64; then 258 if use ppc64; then
242 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
243 append-flags -mminimal-toc 260 append-flags -mminimal-toc
244 fi 261 fi
245 262
246 # Bug 282984 && Bug 295530 263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
247 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 264 sed -e "/^SYSTEM_VARIABLES=/i \
248 -i configure || die "sed qmake compilers failed" 265 CC='$(tc-getCC)'\n\
266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n\
270 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
272 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
273 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
274 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
275 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
249 278
250 # Bug 321335 279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
251 if version_is_at_least 4.6; then 286 if ! version_is_at_least 4.8; then
252 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
253 xargs -0 \ 288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
254 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
255 -i || die "sed test compilers failed"
256 fi 289 fi
257 290
258 # Bug 172219 291 # Bug 172219
259 sed -e "s:X11R6/::" \ 292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
260 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
261 293
262 if [[ ${CHOST} == *-darwin* ]]; then 294 if [[ ${CHOST} == *-darwin* ]]; then
263 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
264 # crippled (by design) :/ 296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
265 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
266 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
267 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
268 -e "s:-arch\s\w*::g" \ 311 -e "s:-arch\s\w*::g" \
269 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
270 314
271 # Fix configure's -arch settings that appear in qmake/Makefile and also 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
272 # fix arch handling (automagically duplicates our -arch arg and breaks 316 # fix arch handling (automagically duplicates our -arch arg and breaks
273 # pch). Additionally disable Xarch support. 317 # pch). Additionally disable Xarch support.
318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
274 sed \ 322 sed \
275 -e "s:-arch i386::" \ 323 -e "s:-arch i386::" \
276 -e "s:-arch ppc::" \ 324 -e "s:-arch ppc::" \
277 -e "s:-arch x86_64::" \ 325 -e "s:-arch x86_64::" \
278 -e "s:-arch ppc64::" \ 326 -e "s:-arch ppc64::" \
279 -e "s:-arch \$i::" \ 327 -e "s:-arch \$i::" \
280 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
281 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
282 -e "s:-Xarch_x86_64::g" \ 330 -e "s:-Xarch_x86_64::g" \
283 -e "s:-Xarch_ppc64::g" \ 331 -e "s:-Xarch_ppc64::g" \
284 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
285 334
286 # On Snow Leopard don't fall back to 10.5 deployment target. 335 # On Snow Leopard don't fall back to 10.5 deployment target.
287 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
290 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
291 fi 341 fi
292 fi 342 fi
293 343
294 # this one is needed for all systems with a separate -liconv, apart from 344 # this one is needed for all systems with a separate -liconv, apart from
295 # Darwin, for which the sources already cater for -liconv 345 # Darwin, for which the sources already cater for -liconv
296 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
297 sed \ 347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
298 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
299 -i config.tests/unix/iconv/iconv.pro \ 348 -i config.tests/unix/iconv/iconv.pro \
300 || die "sed on iconv.pro failed" 349 || die "sed iconv.pro failed"
301 fi 350 fi
302 351
303 # we need some patches for Solaris 352 # we need some patches for Solaris
304 sed -i \
305 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
306 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
307 # use GCC over SunStudio 355 # use GCC over SunStudio
308 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
309 # don't flirt with non-Prefix stuff, we're quite possessive 357 # do not flirt with non-Prefix stuff, we're quite possessive
310 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
311 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
312 # strip predefined CFLAGS from qmake ( bug #312689 )
313 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
314 360
315 base_src_prepare 361 # apply patches
362 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
363 epatch_user
316} 364}
317 365
318# @FUNCTION: qt4-build_src_configure 366# @FUNCTION: qt4-build_src_configure
319# @DESCRIPTION: 367# @DESCRIPTION:
320# Default configure phase 368# Default configure phase
321qt4-build_src_configure() { 369qt4-build_src_configure() {
322 setqtenv 370 setqtenv
323 myconf="$(standard_configure_options) ${myconf}" 371
372 local conf="
373 -prefix ${QTPREFIXDIR}
374 -bindir ${QTBINDIR}
375 -libdir ${QTLIBDIR}
376 -docdir ${QTDOCDIR}
377 -headerdir ${QTHEADERDIR}
378 -plugindir ${QTPLUGINDIR}
379 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
380 -datadir ${QTDATADIR}
381 -translationdir ${QTTRANSDIR}
382 -sysconfdir ${QTSYSCONFDIR}
383 -examplesdir ${QTEXAMPLESDIR}
384 -demosdir ${QTDEMOSDIR}
385 -opensource -confirm-license
386 -shared -fast -largefile -stl -verbose
387 -nomake examples -nomake demos"
388
389 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
390 # $(tc-arch). Therefore we convert it to supported values.
391 case "$(tc-arch)" in
392 amd64|x64-*) conf+=" -arch x86_64" ;;
393 ppc-macos) conf+=" -arch ppc" ;;
394 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
395 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
396 x86-macos) conf+=" -arch x86" ;;
397 x86|x86-*) conf+=" -arch i386" ;;
398 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
399 hppa|sh) conf+=" -arch generic" ;;
400 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
401 esac
402
403 conf+=" -platform $(qt_mkspecs_dir)"
404
405 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
406
407 # debug/release
408 if use debug; then
409 conf+=" -debug"
410 else
411 conf+=" -release"
412 fi
413 conf+=" -no-separate-debug-info"
414
415 # exceptions USE flag
416 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
417
418 # disable rpath on Qt >= 4.8 (bug 380415)
419 # but leave it enabled on prefix (bug 417169)
420 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
421
422 # precompiled headers don't work on hardened, where the flag is masked
423 conf+=" $(qt_use pch)"
424
425 # -reduce-relocations
426 # This flag seems to introduce major breakage to applications,
427 # mostly to be seen as a core dump with the message "QPixmap: Must
428 # construct a QApplication before a QPaintDevice" on Solaris.
429 # -- Daniel Vergien
430 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
324 431
325 # this one is needed for all systems with a separate -liconv, apart from 432 # this one is needed for all systems with a separate -liconv, apart from
326 # Darwin, for which the sources already cater for -liconv 433 # Darwin, for which the sources already cater for -liconv
327 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 434 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
328 myconf+=" -liconv" 435 conf+=" -liconv"
436 fi
329 437
330 if use_if_iuse glib; then 438 if use_if_iuse glib; then
331 # use -I, -L and -l from configure
332 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 439 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
333 # avoid the -pthread argument 440 # avoid the -pthread argument
334 myconf+=" ${glibflags//-pthread}" 441 conf+=" ${glibflags//-pthread}"
335 unset glibflags 442 unset glibflags
336 fi 443 fi
337 444
338 if use_if_iuse qpa; then 445 if use_if_iuse qpa; then
339 ewarn 446 echo
340 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 447 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
341 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 448 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
342 ewarn "disable it before reporting any bugs related to this useflag." 449 ewarn "disable it before reporting any bugs related to this useflag."
343 ewarn 450 echo
344 myconf+=" -qpa" 451 conf+=" -qpa"
345 fi 452 fi
346 453
347 if use aqua ; then 454 if use aqua; then
348 # On (snow) leopard use the new (frameworked) cocoa code. 455 # On (snow) leopard use the new (frameworked) cocoa code.
349 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 456 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
350 myconf+=" -cocoa -framework" 457 conf+=" -cocoa -framework"
458 # We need the source's headers, not the installed ones.
459 conf+=" -I${S}/include"
460 # Add hint for the framework location.
461 conf+=" -F${QTLIBDIR}"
351 462
352 # We are crazy and build cocoa + qt3support :-) 463 # We are crazy and build cocoa + qt3support :-)
353 if use qt3support; then 464 if use qt3support; then
354 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 465 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
355 -i configure 466 -i configure || die
356 fi 467 fi
357 468 else
358 # We need the source's headers, not the installed ones. 469 conf+=" -no-framework"
359 myconf+=" -I${S}/include"
360
361 # Add hint for the framework location.
362 myconf+=" -F${QTLIBDIR}"
363 fi 470 fi
364 else 471 else
365 # freetype2 include dir is non-standard, thus include it on configure 472 # freetype2 include dir is non-standard, thus pass it to configure
366 # use -I from configure
367 myconf+=" $(pkg-config --cflags freetype2)" 473 conf+=" $(pkg-config --cflags-only-I freetype2)"
368 fi 474 fi
369 475
476 conf+=" ${myconf}"
477 myconf=
478
370 echo ./configure ${myconf} 479 echo ./configure ${conf}
371 ./configure ${myconf} || die "./configure failed" 480 ./configure ${conf} || die "./configure failed"
372 myconf=""
373 481
374 prepare_directories ${QT4_TARGET_DIRECTORIES} 482 prepare_directories ${QT4_TARGET_DIRECTORIES}
375} 483}
376 484
377# @FUNCTION: qt4-build_src_compile 485# @FUNCTION: qt4-build_src_compile
385 493
386# @FUNCTION: qt4-build_src_test 494# @FUNCTION: qt4-build_src_test
387# @DESCRIPTION: 495# @DESCRIPTION:
388# Runs tests only in target directories. 496# Runs tests only in target directories.
389qt4-build_src_test() { 497qt4-build_src_test() {
498 # QtMultimedia does not have any test suite (bug #332299)
499 [[ ${PN} == qt-multimedia ]] && return
500
390 for dir in ${QT4_TARGET_DIRECTORIES}; do 501 for dir in ${QT4_TARGET_DIRECTORIES}; do
391 emake -j1 check -C ${dir} 502 emake -j1 check -C ${dir}
392 done 503 done
393} 504}
394 505
395# @FUNCTION: fix_includes 506# @FUNCTION: fix_includes
396# @DESCRIPTION: 507# @DESCRIPTION:
397# For MacOSX we need to add some symlinks when frameworks are 508# For MacOS X we need to add some symlinks when frameworks are
398# being used, to avoid complications with some more or less stupid packages. 509# being used, to avoid complications with some more or less stupid packages.
399fix_includes() { 510fix_includes() {
400 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 511 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
512 local frw dest f h rdir
401 # Some packages tend to include <Qt/...> 513 # Some packages tend to include <Qt/...>
402 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 514 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
403 515
404 # Fake normal headers when frameworks are installed... eases life later on 516 # Fake normal headers when frameworks are installed... eases life later
405 local dest f 517 # on, make sure we use relative links though, as some ebuilds assume
518 # these dirs exist in src_install to add additional files
519 f=${QTHEADERDIR}
520 h=${QTLIBDIR}
521 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
522 f=${f#*/}
523 h=${h#*/}
524 done
525 rdir=${h}
526 f="../"
527 while [[ ${h} == */* ]] ; do
528 f="${f}../"
529 h=${h#*/}
530 done
531 rdir="${f}${rdir}"
532
406 for frw in "${D}${QTLIBDIR}"/*.framework; do 533 for frw in "${D}${QTLIBDIR}"/*.framework; do
407 [[ -e "${frw}"/Headers ]] || continue 534 [[ -e "${frw}"/Headers ]] || continue
408 f=$(basename ${frw}) 535 f=$(basename ${frw})
409 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 536 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
410 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 537 dosym "${rdir}"/${f}/Headers "${dest}"
411 538
412 # Link normal headers as well. 539 # Link normal headers as well.
413 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 540 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
414 h=$(basename ${hdr}) 541 h=$(basename ${hdr})
415 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 542 dosym "../${rdir}"/${f}/Headers/${h} \
543 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
416 done 544 done
417 done 545 done
418 fi 546 fi
419} 547}
420 548
429 install_qconfigs 557 install_qconfigs
430 fix_library_files 558 fix_library_files
431 fix_includes 559 fix_includes
432 560
433 # remove .la files since we are building only shared Qt libraries 561 # remove .la files since we are building only shared Qt libraries
434 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 562 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
435} 563}
436 564
437# @FUNCTION: setqtenv 565# @FUNCTION: setqtenv
566# @INTERNAL
438setqtenv() { 567setqtenv() {
439 # Set up installation directories 568 # Set up installation directories
440 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
441 QTPREFIXDIR=${EPREFIX}/usr 569 QTPREFIXDIR=${EPREFIX}/usr
442 QTBINDIR=${EPREFIX}/usr/bin 570 QTBINDIR=${EPREFIX}/usr/bin
443 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 571 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
444 QMAKE_LIBDIR_QT=${QTLIBDIR}
445 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 572 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
446 QTDATADIR=${EPREFIX}/usr/share/qt4
447 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 573 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
448 QTHEADERDIR=${EPREFIX}/usr/include/qt4 574 QTHEADERDIR=${EPREFIX}/usr/include/qt4
449 QTPLUGINDIR=${QTLIBDIR}/plugins 575 QTPLUGINDIR=${QTLIBDIR}/plugins
450 QTIMPORTDIR=${QTLIBDIR}/imports 576 QTIMPORTDIR=${QTLIBDIR}/imports
577 QTDATADIR=${EPREFIX}/usr/share/qt4
578 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4 579 QTSYSCONFDIR=${EPREFIX}/etc/qt4
452 QTTRANSDIR=${QTDATADIR}/translations
453 QTEXAMPLESDIR=${QTDATADIR}/examples 580 QTEXAMPLESDIR=${QTDATADIR}/examples
454 QTDEMOSDIR=${QTDATADIR}/demos 581 QTDEMOSDIR=${QTDATADIR}/demos
582 QMAKE_LIBDIR_QT=${QTLIBDIR}
455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 583 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
584
456 PLATFORM=$(qt_mkspecs_dir) 585 PLATFORM=$(qt_mkspecs_dir)
457
458 unset QMAKESPEC 586 unset QMAKESPEC
459}
460 587
461# @FUNCTION: standard_configure_options 588 export XDG_CONFIG_HOME="${T}"
462# @DESCRIPTION:
463# Sets up some standard configure options, like libdir (if necessary), whether
464# debug info is wanted or not.
465standard_configure_options() {
466 local myconf=
467
468 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
469
470 # Disable visibility explicitly if gcc version isn't 4
471 if [[ $(gcc-major-version) -lt 4 ]]; then
472 myconf+=" -no-reduce-exports"
473 fi
474
475 # precompiled headers doesn't work on hardened, where the flag is masked.
476 myconf+=" $(qt_use pch)"
477
478 if use debug; then
479 myconf+=" -debug"
480 else
481 myconf+=" -release"
482 fi
483 myconf+=" -no-separate-debug-info"
484
485 use aqua && myconf+=" -no-framework"
486
487 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
488 # $(tc-arch). Therefore we convert it to supported values.
489 case "$(tc-arch)" in
490 amd64|x64-*) myconf+=" -arch x86_64" ;;
491 ppc-macos) myconf+=" -arch ppc" ;;
492 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
493 sparc|sparc-*|sparc64-*) myconf+=" -arch sparc" ;;
494 x86-macos) myconf+=" -arch x86" ;;
495 x86|x86-*) myconf+=" -arch i386" ;;
496 alpha|arm|ia64|mips|s390) myconf+=" -arch $(tc-arch)" ;;
497 hppa|sh) myconf+=" -arch generic" ;;
498 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
499 esac
500
501 # exceptions USE flag
502 local exceptions="-exceptions"
503 in_iuse exceptions && exceptions="$(qt_use exceptions)"
504
505 # bug 380415
506 version_is_at_least 4.8 && myconf+=" -no-rpath"
507
508 # note about -reduce-relocations:
509 # That flag seems to introduce major breakage to applications,
510 # mostly to be seen as a core dump with the message "QPixmap: Must
511 # construct a QApplication before a QPaintDevice" on Solaris
512 # -- Daniel Vergien
513 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
514
515 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
516 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
517 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
518 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
519 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
520 -demosdir ${QTDEMOSDIR} -importdir ${QTIMPORTDIR} -silent -fast -opensource
521 ${exceptions}
522 -nomake examples -nomake demos"
523
524 echo "${myconf}"
525} 589}
526 590
527# @FUNCTION: prepare_directories 591# @FUNCTION: prepare_directories
528# @USAGE: < directories > 592# @USAGE: < directories >
593# @INTERNAL
529# @DESCRIPTION: 594# @DESCRIPTION:
530# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 595# Generates Makefiles for the given list of directories.
531prepare_directories() { 596prepare_directories() {
532 for x in "$@"; do 597 for x in "$@"; do
533 pushd "${S}"/${x} >/dev/null 598 pushd "${S}"/${x} >/dev/null || die
534 einfo "Running qmake in: ${x}" 599 einfo "Running qmake in: ${x}"
535 # avoid running over the maximum argument number, bug #299810 600 # avoid running over the maximum argument number, bug #299810
536 { 601 {
537 echo "${S}"/mkspecs/common/*.conf 602 echo "${S}"/mkspecs/common/*.conf
538 find "${S}" -name '*.pr[io]' 603 find "${S}" -name '*.pr[io]'
539 } | xargs sed -i \ 604 } | xargs sed -i \
540 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \ 605 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
541 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \ 606 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
542 || die 607 || die
543 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 608 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
544 popd >/dev/null 609 popd >/dev/null || die
545 done 610 done
546} 611}
547 612
548 613
549# @FUNCTION: build_directories 614# @FUNCTION: build_directories
550# @USAGE: < directories > 615# @USAGE: < directories >
616# @INTERNAL
551# @DESCRIPTION: 617# @DESCRIPTION:
552# Compiles the code in $QT4_TARGET_DIRECTORIES 618# Compiles the code in the given list of directories.
553build_directories() { 619build_directories() {
554 for x in "$@"; do 620 for x in "$@"; do
555 pushd "${S}"/${x} >/dev/null 621 pushd "${S}"/${x} >/dev/null || die
556 emake CC="$(tc-getCC)" \ 622 emake CC="$(tc-getCC)" \
557 CXX="$(tc-getCXX)" \ 623 CXX="$(tc-getCXX)" \
558 LINK="$(tc-getCXX)" || die "emake failed" 624 LINK="$(tc-getCXX)" || die "emake failed"
559 popd >/dev/null 625 popd >/dev/null || die
560 done 626 done
561} 627}
562 628
563# @FUNCTION: install_directories 629# @FUNCTION: install_directories
564# @USAGE: < directories > 630# @USAGE: < directories >
631# @INTERNAL
565# @DESCRIPTION: 632# @DESCRIPTION:
566# run emake install in the given directories, which are separated by spaces 633# Runs emake install in the given directories, which are separated by spaces.
567install_directories() { 634install_directories() {
568 for x in "$@"; do 635 for x in "$@"; do
569 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 636 pushd "${S}"/${x} >/dev/null || die
570 emake INSTALL_ROOT="${D}" install || die "emake install failed" 637 emake INSTALL_ROOT="${D}" install || die "emake install failed"
571 popd >/dev/null || die "Can't popd from ${S}/${x}" 638 popd >/dev/null || die
572 done 639 done
573} 640}
574 641
575# @ECLASS-VARIABLE: QCONFIG_ADD 642# @ECLASS-VARIABLE: QCONFIG_ADD
576# @DESCRIPTION: 643# @DESCRIPTION:
586# @DESCRIPTION: 653# @DESCRIPTION:
587# List variables that should be defined at the top of QtCore/qconfig.h 654# List variables that should be defined at the top of QtCore/qconfig.h
588: ${QCONFIG_DEFINE:=} 655: ${QCONFIG_DEFINE:=}
589 656
590# @FUNCTION: install_qconfigs 657# @FUNCTION: install_qconfigs
658# @INTERNAL
591# @DESCRIPTION: 659# @DESCRIPTION:
592# Install gentoo-specific mkspecs configurations 660# Install gentoo-specific mkspecs configurations.
593install_qconfigs() { 661install_qconfigs() {
594 local x 662 local x
595 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 663 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
596 for x in QCONFIG_ADD QCONFIG_REMOVE; do 664 for x in QCONFIG_ADD QCONFIG_REMOVE; do
597 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 665 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
608 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 676 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
609 fi 677 fi
610} 678}
611 679
612# @FUNCTION: generate_qconfigs 680# @FUNCTION: generate_qconfigs
681# @INTERNAL
613# @DESCRIPTION: 682# @DESCRIPTION:
614# Generates gentoo-specific configurations 683# Generates gentoo-specific qconfig.{h,pri}.
615generate_qconfigs() { 684generate_qconfigs() {
616 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 685 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
617 local x qconfig_add qconfig_remove qconfig_new 686 local x qconfig_add qconfig_remove qconfig_new
618 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 687 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
619 [[ -f ${x} ]] || continue 688 [[ -f ${x} ]] || continue
620 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 689 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
621 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 690 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
668 fi 737 fi
669} 738}
670 739
671# @FUNCTION: qt4-build_pkg_postrm 740# @FUNCTION: qt4-build_pkg_postrm
672# @DESCRIPTION: 741# @DESCRIPTION:
673# Generate configurations when the package is completely removed 742# Regenerate configuration when the package is completely removed.
674qt4-build_pkg_postrm() { 743qt4-build_pkg_postrm() {
675 generate_qconfigs 744 generate_qconfigs
676} 745}
677 746
678# @FUNCTION: qt4-build_pkg_postinst 747# @FUNCTION: qt4-build_pkg_postinst
679# @DESCRIPTION: 748# @DESCRIPTION:
680# Generate configuration, plus throws a message about possible 749# Regenerate configuration, plus throw a message about possible
681# breakages and proposed solutions. 750# breakages and proposed solutions.
682qt4-build_pkg_postinst() { 751qt4-build_pkg_postinst() {
683 generate_qconfigs 752 generate_qconfigs
684} 753}
685 754
686# @FUNCTION: skip_qmake_build 755# @FUNCTION: skip_qmake_build
756# @INTERNAL
687# @DESCRIPTION: 757# @DESCRIPTION:
688# Don't need to build qmake, as it's already installed from qt-core 758# Patches configure to skip qmake compilation, as it's already installed by qt-core.
689skip_qmake_build() { 759skip_qmake_build() {
690 # Don't need to build qmake, as it's already installed from qt-core
691 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed" 760 sed -i -e "s:if true:if false:g" "${S}"/configure || die
692} 761}
693 762
694# @FUNCTION: skip_project_generation 763# @FUNCTION: skip_project_generation
764# @INTERNAL
695# @DESCRIPTION: 765# @DESCRIPTION:
696# Exit the script early by throwing in an exit before all of the .pro files are scanned 766# Exit the script early by throwing in an exit before all of the .pro files are scanned.
697skip_project_generation() { 767skip_project_generation() {
698 # Exit the script early by throwing in an exit before all of the .pro files are scanned
699 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 768 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
700 -i "${S}"/configure || die "sed failed"
701} 769}
702 770
703# @FUNCTION: symlink_binaries_to_buildtree 771# @FUNCTION: symlink_binaries_to_buildtree
772# @INTERNAL
704# @DESCRIPTION: 773# @DESCRIPTION:
705# Symlink generated binaries to buildtree so they can be used during compilation 774# Symlinks generated binaries to buildtree, so they can be used during compilation time.
706# time
707symlink_binaries_to_buildtree() { 775symlink_binaries_to_buildtree() {
708 for bin in qmake moc uic rcc; do 776 for bin in qmake moc uic rcc; do
709 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed" 777 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
710 done 778 done
711} 779}
712 780
713# @FUNCTION: fix_library_files 781# @FUNCTION: fix_library_files
782# @INTERNAL
714# @DESCRIPTION: 783# @DESCRIPTION:
715# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 784# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
716# moves the *.pc-files into the pkgconfig directory 785# moves the *.pc files into the pkgconfig directory.
717fix_library_files() { 786fix_library_files() {
787 local libfile
718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 788 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
719 if [[ -e ${libfile} ]]; then 789 if [[ -e ${libfile} ]]; then
720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed" 790 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
721 fi 791 fi
722 done 792 done
723 793
724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 794 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 795 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
726 if [[ -e ${libfile} ]]; then 796 if [[ -e ${libfile} ]]; then
727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed" 797 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
728 798
729 # Move .pc files into the pkgconfig directory 799 # Move .pc files into the pkgconfig directory
730 dodir ${QTPCDIR#${EPREFIX}} 800 dodir ${QTPCDIR#${EPREFIX}}
731 mv ${libfile} "${D}"/${QTPCDIR}/ \ 801 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
732 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
733 fi 802 fi
734 done 803 done
735 804
736 # Don't install an empty directory 805 # Don't install an empty directory
737 rmdir "${D}"/${QTLIBDIR}/pkgconfig 806 rmdir "${D}"/${QTLIBDIR}/pkgconfig
738} 807}
739 808
740# @FUNCTION: qt_use 809# @FUNCTION: qt_use
741# @USAGE: < flag > [ feature ] [ enableval ] 810# @USAGE: < flag > [ feature ] [ enableval ]
742# @DESCRIPTION: 811# @DESCRIPTION:
743# This will echo "${enableval}-${feature}" if <flag> is enabled, or 812# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
744# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 813# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
745# will be used for that. If [enableval] is not specified, it omits the 814# will be used for that. If [enableval] is not specified, it omits the
746# assignment-part 815# "-${enableval}" part.
747qt_use() { 816qt_use() {
748 local flag=$1 817 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
749 local feature=$1
750 local enableval=
751
752 [[ -n $2 ]] && feature=$2
753 [[ -n $3 ]] && enableval=-$3
754
755 if use ${flag}; then
756 echo "${enableval}-${feature}"
757 else
758 echo "-no-${feature}"
759 fi
760} 818}
761 819
762# @FUNCTION: qt_mkspecs_dir 820# @FUNCTION: qt_mkspecs_dir
763# @RETURN: the specs-directory w/o path 821# @RETURN: the specs-directory w/o path
764# @DESCRIPTION: 822# @DESCRIPTION:
765# Allows us to define which mkspecs dir we want to use. 823# Allows us to define which mkspecs dir we want to use.
766qt_mkspecs_dir() { 824qt_mkspecs_dir() {
767 # Allows us to define which mkspecs dir we want to use.
768 local spec 825 local spec=
769 826
770 case ${CHOST} in 827 case "${CHOST}" in
771 *-freebsd*|*-dragonfly*) 828 *-freebsd*|*-dragonfly*)
772 spec=freebsd ;; 829 spec=freebsd ;;
773 *-openbsd*) 830 *-openbsd*)
774 spec=openbsd ;; 831 spec=openbsd ;;
775 *-netbsd*) 832 *-netbsd*)
786 *-solaris*) 843 *-solaris*)
787 spec=solaris ;; 844 spec=solaris ;;
788 *-linux-*|*-linux) 845 *-linux-*|*-linux)
789 spec=linux ;; 846 spec=linux ;;
790 *) 847 *)
791 die "Unknown CHOST, no platform chosen" 848 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
792 esac 849 esac
793 850
794 CXX=$(tc-getCXX) 851 case "$(tc-getCXX)" in
795 if [[ ${CXX} == *g++* ]]; then 852 *g++*)
796 spec+=-g++ 853 spec+=-g++ ;;
797 elif [[ ${CXX} == *icpc* ]]; then 854 *icpc*)
798 spec+=-icc 855 spec+=-icc ;;
799 else 856 *)
800 die "Unknown compiler '${CXX}'" 857 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
801 fi 858 esac
802 if [[ -n ${LIBDIR/lib} ]]; then
803 spec+=-${LIBDIR/lib}
804 fi
805 859
806 # Add -64 for 64bit profiles 860 # Add -64 for 64bit profiles
807 if use x64-freebsd || 861 if use x64-freebsd ||
808 use amd64-linux || 862 use amd64-linux ||
809 use x64-macos || 863 use x64-macos ||
814 fi 868 fi
815 869
816 echo "${spec}" 870 echo "${spec}"
817} 871}
818 872
819# @FUNCTION: qt_assistant_cleanup
820# @RETURN: nothing
821# @DESCRIPTION:
822# Tries to clean up tools.pro for qt-assistant ebuilds.
823# Meant to be called in src_prepare().
824# Since Qt 4.7.4 this function is a no-op.
825qt_assistant_cleanup() {
826 # apply patching to qt-assistant ebuilds only
827 [[ ${PN} != "qt-assistant" ]] && return
828
829 # no longer needed for 4.7.4 and later
830 version_is_at_least "4.7.4" && return
831
832 # different versions (and branches...) may need different handling,
833 # add a case if you need special handling
834 case "${MY_PV_EXTRA}" in
835 *kde-qt*)
836 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
837 -e "/mac/,/^embedded.*makeqpf$/d" \
838 -i tools/tools.pro || die "patching tools.pro failed"
839 ;;
840 *)
841 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
842 -e "/mac/,/^embedded.*makeqpf$/d" \
843 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
844 -i tools/tools.pro || die "patching tools.pro failed"
845 ;;
846 esac
847}
848
849# @FUNCTION: qt_nolibx11 873# @FUNCTION: qt_nolibx11
850# @RETURN: nothing 874# @INTERNAL
851# @DESCRIPTION: 875# @DESCRIPTION:
852# Ignore X11 tests for packages that don't need X libraries installed 876# Ignore X11 tests for packages that don't need X libraries installed.
853qt_nolibx11() { 877qt_nolibx11() {
854 einfo "Removing X11 check to allow X-less compilation"
855 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 878 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
856 die "x11 check sed failed" 879 die "x11 check sed failed"
857} 880}
858 881
859EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 882EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.106  
changed lines
  Added in v.1.138

  ViewVC Help
Powered by ViewVC 1.1.20